<template>
  <div class="page">
    <div class="ele-body">
      <a-card :bordered="false" :body-style="{ padding: '16px' }">
        <ele-pro-table
          ref="tableRef"
          row-key="oaAssetsSiteId"
          :columns="columns"
          :datasource="datasource"
          :parse-data="parseData"
          :customRow="customRow"
          tool-class="ele-toolbar-form"
          class="sys-org-table"
        >
          <template #toolbar>
            <search
              @search="reload"
              :selection="selection"
              :website="website"
              @add="openEdit"
              @remove="removeBatch"
              @batchMove="openMove"
            />
          </template>
          <template #bodyCell="{ column, record }">

            <template v-if="column.key === 'websiteLogo'">
              <a-avatar :src="record.websiteLogo" :width="50" />
            </template>
            <template v-if="column.key === 'domain'">
              <a-button
                v-if="record.domain"
                type="link"
                @click="openSpmUrl(`https://${record.domain}`, record)"
              >
                {{ record.domain }}
              </a-button>
              <a-button
                type="link"
                v-if="!record.domain"
                @click="
                  openSpmUrl(
                    `https://${record.websiteCode}.wsdns.cn`,
                    record,
                    record.websiteId
                  )
                "
              >
                {{ record.websiteCode ? `${record.websiteCode}.wsdns.cn` : '' }}
              </a-button>
            </template>
            <template v-if="column.key === 'type'">
              <a-tag v-if="record.type === 1" color="green">是</a-tag>
              <a-tag
                v-if="record.type === 0"
                @click="updateType(record)"
                class="cursor-pointer"
              >否</a-tag
              >
            </template>
            <template v-if="column.key === 'version'">
              <a-tag v-if="record.version === 10" class="cursor-pointer">基础版</a-tag>
              <a-tag color="blue" v-if="record.version === 20" class="cursor-pointer">专业版</a-tag>
              <a-tag color="cyan" v-if="record.version === 30">永久授权</a-tag>
            </template>
            <template v-if="column.key === 'status'">
              <a-tag v-if="record.running === 0" color="red">未开通</a-tag>
              <a-tag v-if="record.running === 1" color="green">运行中</a-tag>
              <a-tag v-if="record.running === 2" color="orange">维护中</a-tag>
              <a-tag v-if="record.running === 3" color="red">已关闭</a-tag>
              <a-tag v-if="record.running === 4" color="red">已欠费停机</a-tag>
              <a-tag v-if="record.running === 5" color="red">违规关停</a-tag>
            </template>
            <template v-if="column.key === 'expirationTime'">
              <div class="text-gray-400">{{ toDateString(record.createTime,'YYYY-MM-dd') }}</div>
              <div class="text-gray-400">{{ toDateString(record.expirationTime,'YYYY-MM-dd') }}</div>
              <a-tag v-if="record.status < 0 && record.soon < 0" color="red">已过期</a-tag>
              <a-tag v-if="record.status > 0 && record.soon < 0" color="orange">即将过期</a-tag>
            </template>
            <template v-if="column.key === 'action'">
              <a-space>
                <a class="text-gray-800" @click="openAdmin(record)">控制台</a>
                <a-divider type="vertical" />
                <a @click="openEdit(record)">编辑</a>
                <a-divider type="vertical" />
                <a-popconfirm
                  placement="topRight"
                  title="确定要删除此菜单吗？"
                  @confirm="remove(record)"
                >
                  <a class="ele-text-danger">删除</a>
                </a-popconfirm>
              </a-space>
            </template>
          </template>
        </ele-pro-table>
      </a-card>

      <!-- 编辑弹窗 -->
      <OaAssetsSiteEdit v-model:visible="showEdit" :data="current" @done="reload" />
    </div>
  </div>
</template>

<script lang="ts" setup>
  import { createVNode, ref } from 'vue';
  import { message, Modal } from 'ant-design-vue';
  import { ExclamationCircleOutlined } from '@ant-design/icons-vue';
  import type { EleProTable } from 'ele-admin-pro';
  import { toDateString } from 'ele-admin-pro';
  import type {
    DatasourceFunction,
    ColumnItem
  } from 'ele-admin-pro/es/ele-pro-table/types';
  import Search from './components/search.vue';
  import OaAssetsSiteEdit from './components/oaAssetsSiteEdit.vue';
  import { removeOaAssetsSite, removeBatchOaAssetsSite } from '@/api/oa/oaAssetsSite';
  import type { OaAssetsSite, OaAssetsSiteParam } from '@/api/oa/oaAssetsSite/model';
  import {openSpmUrl} from "@/utils/common";
  import {PageResult} from "@/api";
  import {updateCmsWebsite} from "@/api/cms/cmsWebsite";
  import {pageCmsWebsiteAll} from "@/api/cms/cmsWebsiteAll";

  // 表格实例
  const tableRef = ref<InstanceType<typeof EleProTable> | null>(null);

  // 表格选中数据
  const selection = ref<OaAssetsSite[]>([]);
  // 当前编辑数据
  const current = ref<OaAssetsSite | null>(null);
  // 是否显示编辑弹窗
  const showEdit = ref(false);
  // 是否显示批量移动弹窗
  const showMove = ref(false);
  // 加载状态
  const loading = ref(true);
  // 当前网站项目
  const website = ref<OaAssetsSite>();

  // 表格数据源
  const datasource: DatasourceFunction = ({
    page,
    limit,
    where,
    orders,
    filters
  }) => {
    if (filters) {
      where.status = filters.status;
    }
    where.templateId = 10257;
    return pageCmsWebsiteAll({
      ...where,
      ...orders,
      page,
      limit
    });
  };

  // 表格列配置
  const columns = ref<ColumnItem[]>([
    {
      title: 'LOGO',
      dataIndex: 'websiteLogo',
      key: 'websiteLogo',
      align: 'center'
    },
    {
      title: '网站名称',
      dataIndex: 'websiteName',
      key: 'websiteName'
    },
    {
      title: '域名',
      dataIndex: 'domain',
      key: 'domain',
      align: 'center'
    },
    {
      title: '当前版本',
      dataIndex: 'version',
      key: 'version',
      align: 'center'
    },
    {
      title: '运行状态',
      dataIndex: 'status',
      key: 'status',
      align: 'center'
    },
    {
      title: '操作',
      key: 'action',
      width: 180,
      fixed: 'right',
      align: 'center',
      hideInSetting: true
    }
  ]);

  /* 搜索 */
  const reload = (where?: OaAssetsSiteParam) => {
    selection.value = [];
    tableRef?.value?.reload({ where: where });
  };

  /* 打开编辑弹窗 */
  const openEdit = (row?: OaAssetsSite) => {
    current.value = row ?? null;
    showEdit.value = true;
  };

  const openAdmin = (row?: OaAssetsSite) => {
    if(row?.adminUrl){
      window.open(`https://${row?.adminUrl}`, '_blank')
      return false;
    }else {
      window.open(`https://website.websoft.top`, '_blank')
    }
  }

  /* 打开批量移动弹窗 */
  const openMove = () => {
    showMove.value = true;
  };

  // 整理数据
  const parseData = (data: PageResult<OaAssetsSite>) => {
    if (data?.count > 0) {
      website.value = data.list[0];
    }
    return data;
  };

  const updateType = (row: OaAssetsSite) => {
    updateCmsWebsite(row).then((msg) => {
      message.success(msg);
      reload();
    });
  };

  /* 删除单个 */
  const remove = (row: OaAssetsSite) => {
    const hide = message.loading('请求中..', 0);
    removeOaAssetsSite(row.websiteId)
      .then((msg) => {
        hide();
        message.success(msg);
        reload();
      })
      .catch((e) => {
        hide();
        message.error(e.message);
      });
  };

  /* 批量删除 */
  const removeBatch = () => {
    if (!selection.value.length) {
      message.error('请至少选择一条数据');
      return;
    }
    Modal.confirm({
      title: '提示',
      content: '确定要删除选中的记录吗?',
      icon: createVNode(ExclamationCircleOutlined),
      maskClosable: true,
      onOk: () => {
        const hide = message.loading('请求中..', 0);
        removeBatchOaAssetsSite(selection.value.map((d) => d.websiteId))
          .then((msg) => {
            hide();
            message.success(msg);
            reload();
          })
          .catch((e) => {
            hide();
            message.error(e.message);
          });
      }
    });
  };

  /* 查询 */
  const query = () => {
    loading.value = true;
  };

  /* 自定义行属性 */
  const customRow = (record: OaAssetsSite) => {
    return {
      // 行点击事件
      onClick: () => {
        // console.log(record);
      },
      // 行双击事件
      onDblclick: () => {
        openEdit(record);
      }
    };
  };
  query();
</script>

<script lang="ts">
  export default {
    name: 'OaAssetsSite'
  };
</script>

<style lang="less" scoped></style>
